openapi: 3.1.0
info:
  title: latency.gg demo API
  version: "0.0.0-local"
  description: |
    Specicfication for the demo api, used for demo's

  contact:
    name: latency.gg
    email: info@latency.gg
  
  license:
    name: WTFPL
    url: http://www.wtfpl.net/txt/copying

paths:
  /metrics:
    get:
      operationId: get-metrics
      summary: |
        Retrieve latency metrics and details relating to the probe / requestor.
      responses:
        200:
          description:  OK
          content:
            application/json:
              schema: { $ref: "#/components/schemas/get-metrics-response" }

components:
  schemas:
    get-metrics-response:
      type: object
      additionalProperties: false
      required:
        - source
        - clean_metrics
        - stale_metrics
      properties:
        source:
          description: Requestor's details (Public IP, IP Version used to connect, Ident)
          type: object
          additionalProperties: false
          required:
            - addr
            - version
            - ident
          properties:
            addr:
              description: The requestor's public IP
              type: string
            version:
              description: IP Version used by the requestor to connect (4 or 6)
              type: integer
            ident:
              description: The ident provided by the Latency.GG Client API when you make a request to the /ident/{requestor_ip}
              type: string
        clean_metrics:
          $ref: '#/components/schemas/provider'
          description: Metrics that do not need refreshing
        stale_metrics:
          $ref: '#/components/schemas/provider'
          description: Metrics that need refreshing
    provider:
      type: object
      additionalProperties:
        $ref: '#/components/schemas/location'
    location:
      type: object
      additionalProperties:
        $ref: '#/components/schemas/metric'
    metric:
      type: object
      properties:
        beacons:
          type: array
          description: An aray of beacons that could be measured at the target network
          items:
            $ref: '#/components/schemas/beacon'
        rtt:
          type: integer
          description: The average RTT in the sample window
        stddev:
          type: integer
          description: The standard deviateion of the RTT in the sample window (fast approximation of jitter)
        stale:
          type: boolean
          description: A flag that shows whether the measurement is stale or not
    beacon:
      type: object
      additionalProperties: false
      required:
        - ipv4
        - ipv6
      properties:
        ipv4:
          description: The IPv4 Address of the Beacon
          type: string
          format: ipv4
          example: "203.0.113.3"
        ipv6:
          description: The IPv6 Address of the Beacon
          type: string
          format: ipv6
          example: "2001:db8::2021:6a4f:1"
        beacon:
          type: string
          format: uuid
          description: The uuid of the beacon
        token:
          description: A base64 encoded Curve25519/X25519 SealedBox created using the Beacon's public key containing the string "{timestamp}/{probe_ip}"
          type: string

